module.exports = {
    parser: '@typescript-eslint/parser',
    parserOptions: {
        project: 'tsconfig.json',
        tsconfigRootDir: __dirname,
        sourceType: 'module',
    },
    plugins: ['@typescript-eslint/eslint-plugin'],
    extends: [
        './.eslint-config-preact-nojest.cjs',
        'plugin:@typescript-eslint/strict-type-checked',
        'plugin:prettier/recommended',
    ],
    root: true,
    env: {
        /*node: true,
		jest: true,*/
    },
    ignorePatterns: ['.eslintrc.js'],
    rules: {
        '@typescript-eslint/no-confusing-void-expression': [
            'error',
            { ignoreArrowShorthand: true },
        ],
        /*'@typescript-eslint/no-invalid-void-type': [
            'error',
            { allowAsThisParameter: true },
        ],
        '@typescript-eslint/interface-name-prefix': 'off',
        '@typescript-eslint/explicit-function-return-type': 'off',
        '@typescript-eslint/explicit-module-boundary-types': 'off',*/
    },
};
